using System;
using System.ComponentModel;
using System.Globalization;
using System.Drawing;
using System.Windows.Forms;
[TypeConverter(typeof(MyPointConverter))]
public class MyPoint {
	private int x, y;
	public MyPoint(int x, int y) {
		X = x;
		Y = y;
	}
	public int X {
		get {
			return x;
		}
		set {
			x = value;
		}
	}
	public int Y {
		get {
			return y;
		}
		set {
			y = value;
		}
	}
}
public class MyPointConverter : TypeConverter {
	public override bool CanConvertFrom(ITypeDescriptorContext context, Type srcType) {
		if (srcType == typeof(string))
			return true;
		return base.CanConvertFrom(context, srcType);
	}
	public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value) {
		if (value is string) {
			string[] v = ((string)value).Split(new char[] {','});
			return new MyPoint(int.Parse(v[0]), int.Parse(v[1]));
		}
		return base.ConvertFrom(context, culture, value);
	}
	public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type dstType) {  
		if (dstType == typeof(string))
			return ((MyPoint)value).X + "," + ((MyPoint)value).Y;
		return base.ConvertTo(context, culture, value, dstType);
	}
/*
	public override bool CanConvertTo(ITypeDescriptorContext context, Type dstType) {
		if (dstType == typeof(string))
			return false;
		return base.CanConvertTo(context, dstType);
	}
*/
}
