using System;
using System.Drawing;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Reflection;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
namespace MyControls.Design {
	public class MyPointUIEditor : UITypeEditor {
		public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context) {
			return UITypeEditorEditStyle.DropDown;
		}
		public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value) {
			IWindowsFormsEditorService edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
			if (edSvc == null) return value;
			MyPoint p = value as MyPoint;
			System.Diagnostics.Debug.Assert(p != null);
			MyPointControl mpc = new MyPointControl();
			mpc.Size = new Size(200, 200);
			mpc.Point = p;
			edSvc.DropDownControl(mpc);
			return mpc.Point;
		}
	}
	public class MyPointDesigner : ControlDesigner {
		public override DesignerVerbCollection Verbs {
			get {
				DesignerVerb[] verbs = new DesignerVerb[] {
					new DesignerVerb("Launch MyLabel Designer.(&L)", new EventHandler(launch_designer))
				};
				return new DesignerVerbCollection(verbs);
			}
		}
		void launch_designer(object sender, EventArgs e) {
			Form form = new Form();
			form.Text = "Designer";
			form.ShowDialog();
		}
	}
}
